#include "Atom_group_cache.h"

namespace MM
{

Atom_group_cache::
Atom_group_cache (Atom_group & atom_group)
:
    atom_group_ (atom_group),
    cache_flag_ (false) 
{
}

Atom_group_cache::
~Atom_group_cache () 
{
}

/*void Atom_group_cache::
set_lock (bool on)
{
    if (on)
    {
        REQUIRE ("Unlocked.", !cache_flag_);
        cache_atoms ();
        cache_flag_ = true;
    }
    else
    {
        REQUIRE ("Locked.", cache_flag_);
        flush_force ();
        atom_.clear ();
        cache_flag_ = false;
    }
}//*/

void Atom_group_cache::
cache_atoms ()
{
    atom_.clear ();

    int i, count = atom_group_.atom_count();
    
    for (i=0;  i<count;  ++i) //fix flag___
    {
        Atom &     current = atom_group_.atom (i);
        Atom_kit & kit     = current.kit();
        Atom_cache atom;
        atom.x___           = current.x();
        atom.y___           = current.y();
        atom.z___           = current.z();

        Vector_3D const & force = kit.potential_force ();
        atom.force_x___     = force.x();
        atom.force_y___     = force.y();
        atom.force_z___     = force.z();

        atom.charge___      = current.charge();
        //atom.born_radius___ = kit.born_radius();
        //atom.d_born_radius___ = 0;
        //atom.V___           = kit.volume();
        //atom.Gpol___        = kit.Gpol();              //fix
        //atom.Gpol13___      = kit.Gpol13();              //fix
        atom.transparency___= 1.;
        atom.mm_type___     = kit.mm_type();
        //atom.number___    = model__.atom(i).number_;

        atom.number___      = i;

        atom.origin___      = &atom_group_.atom (i);

        atom_.push_back (atom);

        //atom_.back ().short_list___.reserve (100);
    }//*/

    int stubs = 3;
    //int stubs = 30;

   /*
    for (i=0;  i<stubs;  ++i)
    {
        Atom_cache atom;
        atom.x___           = 123456789;
        atom.y___           = 0;
        atom.z___           = 0;

        atom.force_x___     = 0;
        atom.force_y___     = 0;
        atom.force_z___     = 0;

        atom.charge___      = 0;
        //atom.born_radius___ = 0;
        //atom.d_born_radius___ = 0;
        //atom.V___           = 0;
        //atom.Gpol___        = 0;
        //atom.Gpol13___      = 0;
        atom.transparency___= 0.;
        atom.mm_type___     = 0;

        atom.number___      = -1;//fix
        atom.origin___      = &Atom::none();

        atom_.push_back (atom);
    }//*/

    for (i=0;  i<count;  ++i)
    {
        Atom &     current = atom_group_.atom (i);
        Atom_kit & kit     = current.kit();
        kit.cache___ = &atom_[i];
    }
}

void Atom_group_cache::
flush_force ()
{
    //fix REQUIRE ("Cached", atom_.size() != 0);
    if (atom_.size() == 0)
        return;

    int i, count = atom_group_.atom_count();
    
    for (i=0;  i<count;  ++i)
    {
        Atom_cache & atom = atom_[i];
        Vector_3D_impl force 
            (atom.force_x___, atom.force_y___, atom.force_z___);

        atom_group_.atom (i).kit().set_potential_force (force);
    }
}

//void Atom_group_cache::
//flush_born ()
//{
//    //fix REQUIRE ("Cached", atom_.size() != 0);
//    if (atom_.size() == 0)
//        return;
//
//    int i, count = atom_group_.atom_count();
//    
//    for (i=0;  i<count;  ++i)
//    {
//        Atom_cache & atom = atom_[i];
//        atom_group_.atom (i).kit().set_born_radius (atom.born_radius___);
//        atom_group_.atom (i).kit().set_volume (atom.V___);
//        atom_group_.atom (i).kit().set_Gpol (atom.Gpol___);
//        atom_group_.atom (i).kit().set_Gpol13 (atom.Gpol13___);
//    }
//}

}//MM
