#ifndef LIST_INTERACTIONS_H
#define LIST_INTERACTIONS_H

#ifndef YAKUB_RONCHI_INTERACTIONS_H
#include "Yakub_Ronchi_interactions.h"
#endif

#ifndef NEXT_ATOM_H
#include "Next_atom.h"
#endif

namespace MM
{

class List_interactions : public Yakub_Ronchi_interactions
{
protected:
    //Array <Next_atom>               pair_list_;
    Next_atom *         pair_list_;
    bool                is_locked_;

public:
    ~List_interactions () {delete [] pair_list_;}

    Interaction * clone () const
    {
        return new List_interactions (model_);
            //(atom_group_, bond_group_, force_field_);
    }

    //Common_interactions *   clone (Atom_group &  atom_group,
    //                               Bond_group &  bond_group,
    //                               Force_field & ff) const
    //{return new List_interactions (atom_group, bond_group, ff);}

    Common_interactions *   clone (Model &  model/*,
                                   Force_field & ff*/) const
    {return new List_interactions (model/*, ff*/);}

    //List_interactions (Atom_group & atom_group, Force_field & ff);

    //List_interactions (Atom_group & atom_group,
    //                   Bond_group & bond_group, Force_field & ff);

    List_interactions (Model &  model/*, Force_field & ff*/);

    virtual void        set_lock (bool on);
    virtual bool        locked () const;

    virtual void        make_list ();
    virtual void        make_volumes () {}//fix remove
    virtual void        cache_coords ();

    virtual double      potential ();
    virtual void        add_force ();

    virtual void        full_nonbonded_potential ();
    virtual void        atom_potential (Atom_cache & atom);

    virtual void        calc_nonbonded_force () {}
    virtual void        add_full_nonbonded_force ();
    virtual void        add_atom_force      (Atom_cache & atom);
};

}//MM

#endif //LIST_INTERACTIONS_H
