#include "Profiler.h"

#include "Log.h"

namespace MM
{

Profiler & Profiler::singleton ()
{
    static Profiler instance;
    return instance;
}

void Profiler::
report ()
{
    Text result;

    result += "\n";

    result += "List_interactions ";
    result += List_interactions___add_force___start_count_;
    result += "\n";

    if (List_interactions___add_force___start_ !=0.)
    {
    result += List_interactions___add_force___start_;
    result += " outer\n";
    }

    if (List_interactions___add_force___make_list_ !=0.)
    {
    result += List_interactions___add_force___make_list_;
    result += " make_list\n";
    }

    if (List_interactions___add_force___calc_nonbonded_force_ !=0.)
    {
    result += List_interactions___add_force___calc_nonbonded_force_;
    result += " calc_nonbonded_force\n";
    }

    if (List_interactions___add_force___add_atom_force_ !=0.)
    {
    result += List_interactions___add_force___add_atom_force_;
    result += " add_atom_force\n";
    }

    if (List_interactions___add_force___add_bond_force_ !=0.)
    {
    result += List_interactions___add_force___add_bond_force_;
    result += " add_bond_force\n";
    }

    if (List_interactions___add_force___add_full_nonbonded_force_ !=0.)
    {
    result += List_interactions___add_force___add_full_nonbonded_force_;
    result += " add_full_nonbonded_force\n";
    }

    //=========================================================================
    result += "CUDA_interactions\n...";

    if (CUDA_interactions___add_nonbonded_force___start_ !=0.)
    {
    result += CUDA_interactions___add_nonbonded_force___start_;
    result += " outer\n...";
    }

    if (CUDA_interactions___add_nonbonded_force___set_atom_force_ !=0.)
    {
    result += CUDA_interactions___add_nonbonded_force___set_atom_force_;
    result += " set_atom_force\n...";
    }

    if (CUDA_interactions___add_nonbonded_force___atom_force_to_device_ !=0.)
    {
    result += CUDA_interactions___add_nonbonded_force___atom_force_to_device_;
    result += " atom_force_to_device\n...";
    }

    if (CUDA_interactions___add_nonbonded_force___nonbonded_force_ !=0.)
    {
    result += CUDA_interactions___add_nonbonded_force___nonbonded_force_;
    result += " nonbonded_force\n...";
    }

    if (CUDA_interactions___add_nonbonded_force___atom_force_from_device_ !=0.)
    {
    result += CUDA_interactions___add_nonbonded_force___atom_force_from_device_;
    result += " atom_force_from_device\n...";
    }

    if (CUDA_interactions___add_nonbonded_force___get_atom_force_ !=0.)
    {
    result += CUDA_interactions___add_nonbonded_force___get_atom_force_;
    result += " get_atom_force\n...";
    }

    if (CUDA_interactions___add_nonbonded_force___free_ !=0.)
    {
    result += CUDA_interactions___add_nonbonded_force___free_;
    result += " free\n";
    }
    //=========================================================================

    if (List_interactions___add_force___flush_force_ !=0.)
    {
    result += List_interactions___add_force___flush_force_;
    result += " flush_force\n";
    }

    result += " \n";

    double sum = 
        List_interactions___add_force___start_ +
        List_interactions___add_force___make_list_ +
        List_interactions___add_force___calc_nonbonded_force_ +
        List_interactions___add_force___add_atom_force_ +
        List_interactions___add_force___add_bond_force_ +
        List_interactions___add_force___add_full_nonbonded_force_ +
        List_interactions___add_force___flush_force_ +
        CUDA_interactions___add_nonbonded_force___start_ +
        CUDA_interactions___add_nonbonded_force___set_atom_force_ +
        CUDA_interactions___add_nonbonded_force___atom_force_to_device_ +
        CUDA_interactions___add_nonbonded_force___nonbonded_force_ +
        CUDA_interactions___add_nonbonded_force___atom_force_from_device_ +
        CUDA_interactions___add_nonbonded_force___get_atom_force_ +
        CUDA_interactions___add_nonbonded_force___free_;

    result += sum * List_interactions___add_force___start_count_;
    result += " Sum\n";


    result += " \n";
    result += "\n";

    log () << result;
}

void Profiler::
restart ()
{
    List_interactions___add_force___start_count_                      = 0;

    List_interactions___add_force___start_                            = 0.;
    List_interactions___add_force___make_list_                        = 0.;
    List_interactions___add_force___calc_nonbonded_force_             = 0.;
    List_interactions___add_force___add_atom_force_                   = 0.;
    List_interactions___add_force___add_bond_force_                   = 0.;
    List_interactions___add_force___add_full_nonbonded_force_         = 0.;
    List_interactions___add_force___flush_force_                      = 0.;

    CUDA_interactions___add_nonbonded_force___start_                  = 0.;
    CUDA_interactions___add_nonbonded_force___set_atom_force_         = 0.;
    CUDA_interactions___add_nonbonded_force___atom_force_to_device_   = 0.;
    CUDA_interactions___add_nonbonded_force___nonbonded_force_        = 0.;
    CUDA_interactions___add_nonbonded_force___atom_force_from_device_ = 0.;
    CUDA_interactions___add_nonbonded_force___get_atom_force_         = 0.;
    CUDA_interactions___add_nonbonded_force___free_                   = 0.;

    timer_.restart ();
}

}//MM

