#ifndef PROFILER_H
#define PROFILER_H


#ifndef TIMER_H
#include "Timer.h"
#endif

namespace MM
{

class Profiler
{
    Timer               timer_;

    int    List_interactions___add_force___start_count_;

    double List_interactions___add_force___start_;
    double List_interactions___add_force___make_list_;
    double List_interactions___add_force___calc_nonbonded_force_;
    double List_interactions___add_force___add_atom_force_;
    double List_interactions___add_force___add_bond_force_;
    double List_interactions___add_force___add_full_nonbonded_force_;
    double List_interactions___add_force___flush_force_;

    double CUDA_interactions___add_nonbonded_force___start_;
    double CUDA_interactions___add_nonbonded_force___set_atom_force_;
    double CUDA_interactions___add_nonbonded_force___atom_force_to_device_;
    double CUDA_interactions___add_nonbonded_force___nonbonded_force_;
    double CUDA_interactions___add_nonbonded_force___atom_force_from_device_;
    double CUDA_interactions___add_nonbonded_force___get_atom_force_;
    double CUDA_interactions___add_nonbonded_force___free_;

public:
    static Profiler & singleton ();

    void    restart ();
    void    report  ();

    void List_interactions___add_force___start ()                               {List_interactions___add_force___start_ = timer_.elapsed();  timer_.restart(); ++List_interactions___add_force___start_count_;}
    void List_interactions___add_force___make_list ()                           {List_interactions___add_force___make_list_ = timer_.elapsed();  timer_.restart();}
    void List_interactions___add_force___calc_nonbonded_force ()                {List_interactions___add_force___calc_nonbonded_force_ = timer_.elapsed();  timer_.restart();}
    void List_interactions___add_force___add_atom_force ()                      {List_interactions___add_force___add_atom_force_ = timer_.elapsed();  timer_.restart();}
    void List_interactions___add_force___add_bond_force ()                      {List_interactions___add_force___add_bond_force_ = timer_.elapsed();  timer_.restart();}
    void List_interactions___add_force___add_full_nonbonded_force ()            {List_interactions___add_force___add_full_nonbonded_force_ = timer_.elapsed();  timer_.restart();}
    void List_interactions___add_force___flush_force ()                         {List_interactions___add_force___flush_force_ = timer_.elapsed();  timer_.restart();}

    void CUDA_interactions___add_nonbonded_force___start ()                     {CUDA_interactions___add_nonbonded_force___start_ = timer_.elapsed();  timer_.restart();}
    void CUDA_interactions___add_nonbonded_force___set_atom_force ()            {CUDA_interactions___add_nonbonded_force___set_atom_force_ = timer_.elapsed();  timer_.restart();}
    void CUDA_interactions___add_nonbonded_force___atom_force_to_device ()      {CUDA_interactions___add_nonbonded_force___atom_force_to_device_ = timer_.elapsed();  timer_.restart();}
    void CUDA_interactions___add_nonbonded_force___nonbonded_force ()           {CUDA_interactions___add_nonbonded_force___nonbonded_force_ = timer_.elapsed();  timer_.restart();}
    void CUDA_interactions___add_nonbonded_force___atom_force_from_device ()    {CUDA_interactions___add_nonbonded_force___atom_force_from_device_ = timer_.elapsed();  timer_.restart();}
    void CUDA_interactions___add_nonbonded_force___get_atom_force ()            {CUDA_interactions___add_nonbonded_force___get_atom_force_ = timer_.elapsed();  timer_.restart();}
    void CUDA_interactions___add_nonbonded_force___free ()                      {CUDA_interactions___add_nonbonded_force___free_ = timer_.elapsed();  timer_.restart();}
};

inline Profiler & profile () {return Profiler::singleton ();}

}//MM

#endif //PROFILER_H
