#ifndef AKMA_SYSTEM_OF_UNITS_H
#define AKMA_SYSTEM_OF_UNITS_H

#ifndef SYSTEM_OF_UNITS_H
#include "System_of_Units.h"
#endif

#ifndef LENGTH_UNIT_H
#include "Length_unit.h"
#endif

#ifndef DURATION_UNIT_H
#include "Duration_unit.h"
#endif

#ifndef TEMPERATURE_UNIT_H
#include "Temperature_unit.h"
#endif

namespace MM
{

class AKMA_System_of_Units : public System_of_Units
{
public:
    double      length  (Length_unit const & v) const                           {return v.A();}
    //virtual double      energy  () const = 0;
    //virtual double      mass    () const = 0;
    //virtual double      charge  () const = 0;
    double      time     (Duration_unit const & v,
                                  double * step_length = 0) const
    {
        double result = v.AKMA ();
        if (step_length != 0)
        {
            *step_length = result / v.steps();
        }
        return result;
    }

    void        set_time (Duration_unit & result, double v, double steps) const 
    {
        result.set_AKMA (v); 
        double ps          = result.ps ();
        double step_length = ps / steps;
        result.set_step_length_ps (step_length);


        //result.set_steps (steps);
    }
    //virtual double      force   () const = 0;
    //virtual double      electric_conversion_factor() const = 0;
    double      temperature  (Temperature_unit const &v) const                  {return v.K();}
    void        set_temperature (Temperature_unit & result, double v) const     {result.set_K (v);}

    double      Boltzmann_constant () const                                     {return 0.001987191;} // kcal mol-1 K-1
};

}//MM

#endif //AKMA_SYSTEM_OF_UNITS_H
