#include "Collect_distance.h"

#include "Atom.h"
#include "Atom_group.h"
#include "Point_3D.h"
class Monitor;

namespace MM
{

Collect_distance::
Collect_distance (Atom_group & atom_group)
:
    Collect_scalar (atom_group)
{
    REQUIRE ("", atom_group.atom_count () == 2);
}

Monitor * Collect_distance::
clone (Atom_group & atom_group, Text const &) const
{
    REQUIRE ("", atom_group.atom_count () == 2);
    return new Collect_distance (atom_group);
}

double Collect_distance::
extract_current_value ()
{
    return atom_group().atom(0).position(). distance
          (atom_group().atom(1).position());
}

}//MM
