#include "Collect_scalar.h"

#include "Path.h"
#include "Collect_scalar_to_file.h"
#include "Collect_scalar_to_graph.h"

#include <math.h>
//class MM::Monitor_presentation_frame;

namespace MM
{

Collect_scalar::
Collect_scalar (Atom_group  & atom_group)
:
    Collect_quantity (atom_group)
{
}

Collect_scalar::
Collect_scalar (Atom_group  &                 atom_group,
                Collect_scalar_presentation * new_presentation)
:
    Collect_quantity (atom_group)
{
    adopt (new_presentation);
}

void Collect_scalar::
clear ()
{
    Monitor_frame::clear();//fix

    quantity_sum_.   clear();
    quantity_2_sum_. clear();
}

void Collect_scalar::
handle_execute ()
{
    double current_value   = extract_current_value ();
    double current_value_2 = current_value * current_value;
    
    double last_value      = quantity_sum_.size() == 0 
        ? 0. : quantity_sum_.  back();

    double last_value_2    = quantity_sum_.size() == 0 
        ? 0. : quantity_2_sum_.back();

    quantity_sum_.  push_back (last_value   + current_value);
    quantity_2_sum_.push_back (last_value_2 + current_value_2);

    for (int i=0;  i<presentation_count();  ++i)
        presentation (i).add_data ();
}

double Collect_scalar::
rmsd (int i) const
{
    REQUIRE ("", has_values ());

    double average_2 = average(i);
    average_2 *= average_2;
    return sqrt (quantity_2_sum_[i] / (i+1) - average_2);
}

Collect_scalar * Collect_scalar::
adopt (Collect_scalar_presentation *new_presentation)
{
    adopt_presentation (new_presentation);
    return this;
}

Monitor_presentation * Collect_scalar::
create_file_presentation (Text const& filename)
{
    return new Collect_scalar_to_file (filename, *this);
}

Monitor_presentation * Collect_scalar::
create_graph_presentation (Text const& graphname)
{
    return new Collect_scalar_to_graph (graphname, *this);
}

}//MM





