#ifndef SYSTEM_OF_UNITS_H
#define SYSTEM_OF_UNITS_H

namespace MM
{
class Length_unit;
class Duration_unit;
class Temperature_unit;

class System_of_Units
{
public:
    virtual            ~System_of_Units () ;
    static System_of_Units &    singleton ();

    virtual double      length  (Length_unit const &) const = 0;
    //virtual double      energy  () const = 0;
    //virtual double      mass    () const = 0;
    //virtual double      charge  () const = 0;
    virtual double      time     (Duration_unit const & v,
                                  double * step_length = 0) const = 0;
    virtual void        set_time (Duration_unit & result,
                                  double v, double steps) const = 0;
    //virtual double      force   () const = 0;
    //virtual double      electric_conversion_factor() const = 0;
    virtual double      temperature  (Temperature_unit const &) const = 0;
    virtual void        set_temperature (Temperature_unit & result,
                                         double v) const = 0;

    virtual double      Boltzmann_constant () const =0;
};

}//MM

#endif //SYSTEM_OF_UNITS_H
