#include "Test.h"

#include "System_of_Units.h"
#include "AKMA_System_of_Units.h"

#include "Length_unit.h"
#include "Duration_unit.h"

namespace MM
{

class System_of_Units_test : public Test
{
    System_of_Units *link_1;
    Unit            *link_2;

public:
    System_of_Units_test (const Text & suite_name) : Test(suite_name) { }

    void run ()
    {
        demo();     count_tests();
    }

    void demo()
    {
        AKMA_System_of_Units    AKMA;
        Length_unit             length;
        Duration_unit           time;

        length.set_A  (1.);
        time.set_AKMA (1.);

        DOUBLES_EQUAL (AKMA.length (length), 1., 0.000001);
        DOUBLES_EQUAL (AKMA.time   (time),   1., 0.000001);
    }
};

System_of_Units_test test_System_of_Units ("correctness");

}//MM
