#ifndef VALENT_ANGLE_H
#define VALENT_ANGLE_H

#ifndef DBC_H
#include "DbC.h"
#endif

#ifndef ANGLE_H
#include "Angle.h"
#endif

#ifndef ATOM_H
#include "Atom.h"
#endif

namespace MM
{

class Valent_angle : public Angle, protected DbC
{
    const Atom & atom1_;
    const Atom & atom2_;
    const Atom & atom3_;

public:
    Valent_angle (Atom const & atom1,
                  Atom const & atom2,
                  Atom const & atom3);

    const Atom &    first_atom () const             {return atom1_;}
    const Atom &    second_atom() const             {return atom2_;}
    const Atom &    third_atom () const             {return atom3_;}
};

}//MM

#endif //VALENT_ANGLE_H
