#ifndef ATOM_GROUP_AS_MD_SUBJECT_H
#define ATOM_GROUP_AS_MD_SUBJECT_H

#ifndef MD_SUBJECT_H
#include "MD_subject.h"
#endif

#ifndef OWN_H
#include "Own.h"
#endif

namespace MM
{
class Atom_group;
class Interaction;
class Mass;

class Atom_group_as_md_subject :public MD_subject
{
    Atom_group  &   model_;
    Interaction &   interaction_;
    Own <Mass>      masses_;

public:
    Atom_group_as_md_subject (Atom_group  & model,
                              Interaction & interaction,
                              Mass        * adoptee);

    virtual void        F      (Hint hint);
    virtual void        kick   (double dT);
    virtual void        drift  (double dT);
    virtual void        update ();

private:
    void                update_interactions (Hint hint);
};

}//MM

#endif //ATOM_GROUP_AS_MD_SUBJECT_H
