#ifndef MTS_MD_H
#define MTS_MD_H

#ifndef MD_METHOD_H
#include "MD_method.h"
#endif

#ifndef MD_H
#include "MD.h"
#endif

namespace MM
{

class MTS_MD : public MD_method
{
    int             inner_steps_;

public:        
    explicit MTS_MD (Prototype const &) {adopt_prototype (this);}
    explicit MTS_MD () : inner_steps_(4) { }

//    explicit MTS_MD (MD_subject & subject) : MD_method (subject) { }

    virtual void adopt_inner_step (){}

protected:
    /*virtual Text const& method () const
    {
        static const Text name = MD::method() 
            + ": Multiple time step";
        return name;
    }//*/
    virtual Text const& title () const
    {
        static const Text name = "Multiple time step";
        return name;
    }

    char const *    class_name () const {return "MTS_MD";}
    MD_method *     clone () const      {return new MTS_MD;}

    virtual void start ()
    {
        MD_method::start ();
        F (MD_subject::Long);
    }

    virtual void step ()
    {
        //outer_half_step ();
        kick (.5);

        F (MD_subject::Short);   //fix

        for (int i=0;  i<inner_steps_;  ++i)
        {
            //inner_step ();

            kick  (.5 / inner_steps_);
            drift (1. / inner_steps_);
            F (MD_subject::Short);
            kick  (.5 / inner_steps_);
        }

        //outer_half_step ();
        F (MD_subject::Long);
        kick (.5);
    }

    //virtual void    outer_half_step () =0;
    //virtual void    inner_step () {}
};

}//MM

#endif //MTS_MD_H
