#ifndef PEFRL_H
#define PEFRL_H

#ifndef EFRL_H
#include "EFRL.h"
#endif

namespace MM
{

class PEFRL : public EFRL // Position Extended Forest-Ruth-Like
{
public:
    explicit PEFRL (Prototype const &) {adopt_prototype (this);}
    explicit PEFRL () { }
    //explicit PEFRL (MD_subject & subject) : EFRL (subject) { }
    char const *    class_name () const {return "PEFRL";}
    MD_method *     clone () const      {return new PEFRL;}

protected:
    double  xi    () const {return  0.1786178958448091;}
    double  lambda() const {return -0.2123418310626054;}
    double  chi   () const {return -0.06626458266981849;}

    virtual Text const& title () const
    {
        static const Text name = "Position Extended Forest-Ruth-Like";
        return name;
    }

    virtual void        step   ()
    {
        drift (xi());
        F ();
        kick  ((1.-2.*lambda())/2.);
        drift (chi());
        F ();
        kick  (lambda());
        drift (1.-2.*(chi()+xi()));
        F ();
        kick  (lambda());
        drift (chi());
        F ();
        kick  ((1.-2.*lambda())/2.);
        drift (xi());
    }
};

}//MM

#endif //PEFRL_H
