#ifndef POSITION_LEAPFROG_H
#define POSITION_LEAPFROG_H

#ifndef LEAPFROG_H
#include "Leapfrog.h"
#endif

namespace MM
{
 
class Position_leapfrog : public Leapfrog
{
public:
    explicit Position_leapfrog (Prototype const &) {adopt_prototype (this);}
    explicit Position_leapfrog () { }
    //explicit Position_leapfrog (MD_subject & subject) : Leapfrog (subject) { }
    char const *    class_name () const {return "Position_leapfrog";}
    MD_method *     clone () const      {return new Position_leapfrog;}

protected:
    virtual Text const& title () const
    {
        static const Text name = "Position leapfrog";
        return name;
    }
    virtual int         iterations () const {return simulation().steps()-1;}

    virtual void        start  ()
    {
        MD_method::start ();
        drift (.5);
    }
    virtual void        step   ()
    {
        F ();
        kick  (1.);
        drift (1.);
    }
    virtual void        finish ()
    {
        F ();
        kick  (1.);
        drift (.5);
        MD_method::finish ();
    }
};

}//MM

#endif //POSITION_LEAPFROG_H
