#ifndef VEFRL_H
#define VEFRL_H

#ifndef EFRL_H
#include "EFRL.h"
#endif

namespace MM
{

class VEFRL : public EFRL
{
public:
    explicit VEFRL (Prototype const &) {adopt_prototype (this);}
    explicit VEFRL () { }
    //explicit  VEFRL (MD_subject & subject) : EFRL (subject) { }
    char const *    class_name () const {return "VEFRL";}
    MD_method *     clone () const      {return new VEFRL;}

protected:
    double xi    () const {return  0.1644986515575760;}
    double lambda() const {return -0.02094333910398989;}
    double chi   () const {return  1.235692651138917;}

    virtual Text const& title () const
    {
        static const Text name = "Velocity Extended Forest-Ruth-Like";
        return name;
    }

    virtual void        start  ()
    {
        MD_method::start ();
        F ();
    }

    virtual void        step   ()
    {
        kick  (xi());
        drift ((1.-2.*lambda())/2.);
        F ();
        kick  (chi());
        drift (lambda());
        F ();
        kick  (1.-2.*(chi()+xi()));
        drift (lambda());
        F ();
        kick  (chi());
        drift ((1.-2.*lambda())/2.);
        F ();
        kick  (xi());
    }
};

}//MM

#endif //VEFRL_H
