#ifndef VERLET_H
#define VERLET_H

#ifndef LEAPFROG_H
#include "Leapfrog.h"
#endif

namespace MM
{
 
class Verlet : public Leapfrog
{
public:
    explicit Verlet (Prototype const &) {adopt_prototype (this);}
    explicit Verlet () { }
    //explicit Verlet (MD_subject & subject) : Leapfrog (subject) { }
    char const *    class_name () const {return "Verlet";}
    MD_method *     clone () const      {return new Verlet;}

protected:
    virtual Text const& title () const
    {
        static const Text name = "Position leapfrog";
        return name;
    }
    virtual int         iterations () const {return simulation().steps()-1;}

    virtual void        start  ()
    {
        MD_method::start ();
        //half_drift ();
        //kick        ();
        //half_drift ();
        drift (.5);
        F ();
        kick  (1.);
        drift (.5);
    }
    virtual void        step   ()
    {
        //fix
    }
    virtual void        finish ()
    {
        MD_method::finish ();
    }
};

}//MM

#endif //VERLET_H
