#ifndef LOCK_H
#define LOCK_H

namespace MM
{

template <typename T>
class Lock
{
    T &         obj_;
    bool        flag_;

public:
    explicit    Lock (T & obj) 
        : obj_(obj), flag_(true) 
    {
        if (obj_.locked ())
            flag_ = false;
        else
            obj_.set_lock (true); 
    }
    virtual    ~Lock ()
    {
        if (flag_)
            obj_.set_lock (false);
    }
};

}//MM

#endif //LOCK_H
